#pragma once

// Base Class
#include "../Filter.h"

namespace armarx::armem::server::ltm::processor::filter
{

    class SnapshotFrequencyFilter : public SnapshotFilter
    {
    public:
        static const constexpr char* NAME = "SnapshotFrequencyFilter";
        static const constexpr char* PARAM_WAITING_TIME = "WaitingTimeInMsForFilter";

        SnapshotFrequencyFilter() = default;

        virtual bool accept(const armem::wm::EntitySnapshot &e) override;
        void configure(const nlohmann::json& json) override;

        FilterStatistics getFilterStatistics() override;
        std::string getName() override;

    private:
        std::map<MemoryID, std::int64_t> lastTimesPerEntity;
        int maxDifference = 0;
    };
} // namespace armarx::armem::server::ltm::processor::filter
